﻿using System;
using System.Windows.Controls;
using Stimulsoft.Base.Drawing;
using Stimulsoft.Report;
using System.Reflection;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            StiReport report = new StiReport();
            StreamReader sr = new StreamReader(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("SilverlightApplication1.1.mrt"));

            report.Load(sr.BaseStream);
            sr.Close();
            sr.Dispose();

            report.CalculationMode = StiCalculationMode.Interpretation;
            report.RegBusinessObject("ImageDemo", "ImageDemo", ImageDemo.GetItems(image.Source));
            report.Dictionary.SynchronizeBusinessObjects();

            //this.designerControl.Report = report;
            report.Render();
            this.viewerControl.Report = report;
        }
    }

    public class ImageDemo
    {
        public string Name { get; set; }
        public string Image { get; set; }

        public static ImageDemo GetItems(ImageSource bitmap)
        {
            // a local image
            //BitmapImage bitmap = new BitmapImage(new Uri("/SilverlightApplication1;component/1.png", UriKind.RelativeOrAbsolute));

            // convert to base64 string
            string str = StiImageConverter.ImageToString(bitmap as BitmapImage);
            //string str = GetBase64Image(bitmap); // i try use StiImageConverter.ImageToPackedString(bitmap) or StiImageConverter.ImageToString(bitmap), but the method throw a null point exception.

            // return the object
            return new ImageDemo() { Name = "Test", Image = str };
        }

    } 
}